/* Rulings:  PortalNet Rulings Database for USR Pilot!
 *
 * (c) 1997 Kent L. Smotherman
 * http://www.tconl.com/~kents
 * This is free software!
 */

#pragma pack(2)

#include <Common.h>
#include <System/SysAll.h>
#include <UI/UIAll.h>

#include "rulings.h"

#define rulingsAppType		'RULE'			// type for application.  must be 4 chars, mixed case.
#define rulingsDBType		'Data'			// type for application database.  must be 4 chars, mixed case.
#define rulingsDBName		"Rulings"		// name for application database.  up to 31 characters.

static DmOpenRef		RulingsDB=0;
static VoidPtr  Record0ptr=0;
static VoidHand Record0hand=0;
static ULong Record0size=0;
static VoidPtr  Record1ptr=0;
static VoidHand Record1hand=0;
static ULong Record1size=0;

static VoidHand idxhandle=0;
static char **idxptr=0;

static char *MatchList[20];
static int MatchRec[20];
static int MatchCount;
static char Buffer[8192];
static char Temp[21];
static char Temp2[80];

void Expand(int recnum, char *buffer) {
    VoidHand hand;
    VoidPtr ptr;
    ULong size;
    unsigned char *s,*r,c,*r1,oc;
    unsigned int i,j,flag;
    unsigned int hi,lo;
    ULong n;
	unsigned int rec,idx,skipped;

    j = 0;
    s = buffer;
	//rules are stored 4 rules per .pdb record
	recnum -= 2;
	rec = recnum/4+2;	//from the rule index, get the actual record number
	idx = recnum%4; //get the logical index within the record
	skipped = 0;	//count of skipped rules in this record
    if (hand = DmQueryRecord(RulingsDB,rec)) {
        ptr = MemHandleLock(hand);
        size = MemHandleSize(hand);
        r = ptr;
		oc = 0;
        for (j=0;j<size;j++) {
            c = *r;
			if (skipped != idx) {	//found the rule we're after yet?
				//the next check is tricky...we have to check for the end of rule marker (0) but
				//ensure that it isn't the low 8 bits of a 14 bit index
				if (c == 0 && oc < 0xc0)	//no, is this the end of rule marker?
					skipped++;		//yes, so one more skipped rule
				else {
					oc = c;
				}
				r++;
				continue;
			}
			if (c == 0) break;		//end of rule, done decompressing
            if ((c & 0x80) == 0) {	//uncompressed byte
                *s = c;
                r++;
                s++;
            }
            else {					//compressed
				if ((c & 0xc0) == 0x80) {	//6 bit index into word lookup
					i = c & 0x3f;
					r++;
				}
				else {					//14 bit index into word lookup
					hi = c & 0x3f;
					r++;
					lo = *r;
					r++;
					j++;
					i = (hi<<8)+lo;
				}
				r1 = idxptr[i];	//lookup the word pointer from the index array
                while (*r1) {		//get the word from the word table
                    *s = *r1;
                    s++;
                    r1++;
                }
            }
        }
        *s = 0;
        MemHandleUnlock(hand);
    }
	else {
		StrIToA(Temp,rec);
		StrCopy(Temp2,"Record invalid: ");
		StrCat(Temp2,Temp);
		ErrFatalDisplayIf(1,Temp2);
	}
}

DWord PilotMain(Word cmd, Ptr cmdPBP, Word launchFlags)
{
  short err;
  EventType e;
  void *display;
  void *form,*text,*list;
  int i,count,l;
  char *c,*t;
  ULong tl;
  
  if (!cmd) {
    *Buffer=0;
    *Temp = 0;
	MatchCount = 0;
	RulingsDB = DmOpenDatabaseByTypeCreator(rulingsDBType, rulingsAppType, dmModeReadOnly);
    if (RulingsDB) {
        Record0hand = DmQueryRecord(RulingsDB,0);
        Record0ptr = MemHandleLock(Record0hand);
        Record0size = MemHandleSize(Record0hand);
        Record1hand = DmQueryRecord(RulingsDB,1);
        Record1ptr = MemHandleLock(Record1hand);
        Record1size = MemHandleSize(Record1hand);
		t = Record1ptr;
		tl = 0;
		l = 0;
		for (;tl<Record1size;tl++) {
			if (*t == 0)
				l++;
			t++;
		}
		
		idxhandle = MemHandleNew(l*sizeof(char *));
		ErrFatalDisplayIf(!idxhandle,"Could not allocate buffers");
		idxptr = MemHandleLock(idxhandle);
		MemSet(idxptr,l*(sizeof(char *)),0);
		t = Record1ptr;
		c = t;
		tl = 0;
		l = 0;
		for (;tl<Record1size;tl++) {
			if (*t == 0) {
				idxptr[l] = c;
				c = t+1;
				l++;
			}
			t++;
		}
    }
    FrmGotoForm(SearchForm);

    while(1) {
      EvtGetEvent(&e, -1);
      if (SysHandleEvent(&e)) continue;
      if (MenuHandleEvent((void *)0, &e, &err)) continue;

      switch (e.eType) {

      case ctlSelectEvent:
        if (e.data.ctlSelect.controlID == SearchButton) {
            form = FrmGetActiveForm();
            text = FrmGetObjectPtr(form,FrmGetObjectIndex(form,Name));
            list = FrmGetObjectPtr(form,FrmGetObjectIndex(form,Matches));
            count = 0;
            l = 0;
            c = Record0ptr;
            t = FldGetTextPtr(text);
			StrToLower(Temp,t);
            if (Temp) {
                i = 2;
                while (count < 20 && l < Record0size) {
					StrToLower(Temp2,c);
                    if (StrStr(Temp2,Temp)) {
                        MatchRec[count] = i;
                        MatchList[count++] = c;
                    }
                    c += StrLen(c)+1;
                    l += StrLen(c)+1;
                    i++;
                }
                if (count) {
                    LstSetListChoices(list,MatchList,count);
                    LstDrawList(list);
                }
            }
			MatchCount = count;
        }
        else if (e.data.ctlSelect.controlID == BackButton) {
	        FrmGotoForm(SearchForm);
		}
        break;
      case lstSelectEvent:
        Expand(MatchRec[e.data.lstSelect.selection],Buffer);
        FrmGotoForm(DisplayForm);
        break;
      case frmLoadEvent:
        form = FrmInitForm(e.data.frmLoad.formID);
        FrmSetActiveForm(form);
        if (e.data.frmLoad.formID == DisplayForm) {
            text = FrmGetObjectPtr(form,FrmGetObjectIndex(form,RulingText));
			InsPtEnable(false);
            FldInsert(text,Buffer,StrLen(Buffer));
			FldSetScrollPosition(text,0);
        }
        else if (e.data.frmLoad.formID == SearchForm) {
            text = FrmGetObjectPtr(form,FrmGetObjectIndex(form,Name));
            list = FrmGetObjectPtr(form,FrmGetObjectIndex(form,Matches));
			FldEraseField(text);
			FldDrawField(text);
            if (MatchCount) {
                LstSetListChoices(list,MatchList,count);
                LstDrawList(list);
            }
            i = FrmGetObjectIndex(form,Name);
			FrmSetFocus(form,i);
			FldSetInsPtPosition(text,0);
			l = StrLen(Temp);
			FldInsert(text,Temp,l);
			FldSetSelection(text,0,l);
			InsPtEnable(true);
			FldSetSelection(text,0,l);
//			FldEraseField(text);
//			FldDrawField(text);
		}
        break;

      case frmOpenEvent:
		form = FrmGetActiveForm();
        FrmDrawForm(form);
        break;

      case menuEvent:
		switch (e.data.menu.itemID) {
			case MenuSearch:
				FrmGotoForm(SearchForm);
				break;
		}

        break;

      case appStopEvent:
        FrmCloseAllForms();
		if (idxhandle) {
			MemHandleUnlock(idxhandle);
			MemHandleFree(idxhandle);
		}
        if (Record0hand)
            MemHandleUnlock(Record0hand);
        if (Record1hand)
            MemHandleUnlock(Record1hand);
        if (RulingsDB)
            DmCloseDatabase(RulingsDB);
        return 0;

   	case keyDownEvent:
        form = FrmGetActiveForm();

        if (FrmGetActiveFormID() == DisplayForm) {
            text = FrmGetObjectPtr(form,FrmGetObjectIndex(form,RulingText));
       		if (e.data.keyDown.chr == pageDownChr)
    		{
    		    FldScrollField(text,1,down);
    			break;
    		}

    	    else if (e.data.keyDown.chr == pageUpChr)
    		{
    		    FldScrollField(text,1,up);
    			break;
    		}
    	    //NO break, let default dispatch it
        }
      default:
        FrmHandleEvent(FrmGetActiveForm(), &e);
      }
    }
  }
}
